## openjdk-24 24~30ea

=== test/hotspot/jtreg/testlibrary/ctw/Makefile ===
#
# Copyright (c) 2013, 2024, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#
#

ifneq "x$(ALT_BOOTDIR)" "x"
	BOOTDIR := $(ALT_BOOTDIR)
endif

ifeq "x$(BOOTDIR)" "x"
	JDK_HOME := $(shell dirname $(shell which java))/..
else
	JDK_HOME := $(BOOTDIR)
endif

SRC_DIR = src
BUILD_DIR = build
DST_DIR = dist
OUTPUT_DIR = $(BUILD_DIR)/classes
TESTLIBRARY_DIR = ../../../../../test/lib

JAVAC = $(JDK_HOME)/bin/javac
JAR = $(JDK_HOME)/bin/jar

SRC_FILES = $(shell find $(SRC_DIR) -name '*.java')
# Must exclude files that need '--enable-preview' to compile, if there is any.
LIB_FILES = $(shell find $(TESTLIBRARY_DIR)/jdk/test/lib/ \
    $(TESTLIBRARY_DIR)/jdk/test/lib/process \
    $(TESTLIBRARY_DIR)/jdk/test/lib/util \
    $(TESTLIBRARY_DIR)/jtreg \
    -maxdepth 1 -name '*.java'))
WB_SRC_FILES = $(shell find $(TESTLIBRARY_DIR)/jdk/test/lib/compiler $(TESTLIBRARY_DIR)/jdk/test/whitebox -name '*.java')
WB_CLASS_FILES := $(subst $(TESTLIBRARY_DIR)/,,$(WB_SRC_FILES))
WB_CLASS_FILES := $(patsubst %.java,%.class,$(WB_CLASS_FILES))
EXPORTS=--add-exports java.base/jdk.internal.jimage=ALL-UNNAMED \
	--add-exports java.base/jdk.internal.misc=ALL-UNNAMED \
	--add-exports java.base/jdk.internal.reflect=ALL-UNNAMED \
	--add-exports java.base/jdk.internal.access=ALL-UNNAMED

CTW_MAIN_CLASS = sun.hotspot.tools.ctw.CompileTheWorld
CTWRUNNER_MAIN_CLASS = sun.hotspot.tools.ctw.CtwRunner

.PHONY: clean cleantmp

all: $(DST_DIR)/ctw.zip cleantmp

clean: cleantmp
	@rm -rf $(DST_DIR)

cleantmp:
	@rm -rf filelist wb_filelist manifest.mf
	@rm -rf $(BUILD_DIR)

$(DST_DIR):
	@mkdir -p $@

$(DST_DIR)/ctw.sh: $(DST_DIR)
	echo '$${JAVA_HOME}/bin/java $${JAVA_OPTIONS} $(EXPORTS) -Xbatch "-XX:CompileCommand=exclude,java/lang/invoke/MethodHandle.*" -XX:+UnlockDiagnosticVMOptions -XX:+WhiteBoxAPI -Xbootclasspath/a:wb.jar -jar ctw.jar $$@' > $@
	chmod a+x $@

$(DST_DIR)/ctwrunner.sh: $(DST_DIR)
	echo '$${JAVA_HOME}/bin/java $${JAVA_OPTIONS} -Dtest.jdk=$${JAVA_HOME} -cp ctw.jar $(CTWRUNNER_MAIN_CLASS) $$@' > $@
	chmod a+x $@

$(DST_DIR)/ctw.jar: filelist $(DST_DIR)/wb.jar
	@mkdir -p $(OUTPUT_DIR)
	$(JAVAC) $(EXPORTS) -sourcepath $(SRC_DIR) -d $(OUTPUT_DIR) -cp $(DST_DIR)/wb.jar @filelist
	$(JAR) --create --file=$@ --main-class $(CTW_MAIN_CLASS) -C $(OUTPUT_DIR) .
	@rm -rf $(OUTPUT_DIR)

$(DST_DIR)/wb.jar: wb_filelist $(DST_DIR)
	$(JAVAC)  -sourcepath $(TESTLIBRARY_DIR) \
		-d $(DST_DIR) \
		-cp $(OUTPUT_DIR) \
		@wb_filelist
	cd $(DST_DIR); $(JAR) --create --file=wb.jar $(WB_CLASS_FILES)

$(DST_DIR)/ctw.zip: $(DST_DIR)/ctw.sh $(DST_DIR)/ctwrunner.sh $(DST_DIR)/wb.jar $(DST_DIR)/ctw.jar $(DST_DIR)/ctwrunner.sh
	zip -j $@ $?

wb_filelist: $(WB_SRC_FILES)
	@rm -f $@
	@echo $(WB_SRC_FILES) > $@

filelist: $(SRC_FILES) $(LIB_FILES)
	@rm -f $@
	@echo $(SRC_FILES) $(LIB_FILES) > $@

## openjdk-24 24~10ea

=== debian/changelog ===
openjdk-24 (24~10ea-2) unstable; urgency=medium

  * Fix typo in jre-headless dependencies.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 11 Aug 2024 02:52:32 +0200

openjdk-24 (24~10ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 10.

  [ Vladimir Petko ]
  * d/changelog: Remove trailing empty line.
  * d/copyright-generator/strip-common-licenses.sh: Add GPLv3 to the
    list of common licenses.
  * d/JB-*.overrides.in, d/s/lintian-overrides: Update lintian overrides.
  * d/control: Add Java 24 Provides.
  * d/t/problemlist.csv: Update problemlist.csv for July release
  * d/t/jtreg-autopkgtest.{in,sh}: Increase jtreg test timeouts.

  [ Emmanuel Bourg ]
  * Restore and update the reproducible-properties-timestamp patch.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 10 Aug 2024 15:50:51 +0200

openjdk-24 (24~8ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 8.

  [ Vladimir Petko ]
  * d/t/write-problems.in: Fix typo that caused all tests present
    in d/t/problems.csv to be excluded.
  * d/t/{jdk,hotspot}-autopkgtest.in: Call d/t/write-problems.sh
    instead of d/t/write-problems.
  * d/t/*.sh: Regenerate tests.
  * d/rules: Enable fallback linker for architectures that do not
    provide a native one.
  * d/rules, d/control.in: Depend on pkgconf rather than pkg-config in
    bookworm and later releases. This resolves lintian warning
    build-depends-on-obsolete-package Build-Depends: pkg-config => pkgconf.
  * d/rules: Drop autotools-dev dependency for the modern debhelper.
    This resolves obsolete autotools-dev dependency lintian warning.
    See #844191.
  * d/t/control.in: allow stderr for smoke tests.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 30 Jul 2024 06:17:37 +0200

openjdk-24 (24~7ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 7.

  [ Vladimir Petko ]
  * d/rules: Enable jtreg again.
  * d/t/jni-link.{in,sh}: Drop obsolete test. After JDK-8331541 the build
    will fail if JVM contains undefined symbols.
  * d/rules: Add missing file.
  * d/p/jdk-8334502.patch: Fix iso8601_utctime armhf function.
  * d/p/jdk-8334895-proposed.patch: Resolve configure issue on arm64.
  * d/rules: Include /usr/share/dpkg/buildflags.mk to avoid configure failure
    due to undefined environment variables.
  * d/p/jdk-8335238-workaround.patch: Temporary revert fix for JDK-8320886
    on i386 to fix the ftbfs due to hanging jtreg tests.
  * d/rules, d/t/*: Collate all excluded tests into d/problemlist.csv.
  * d/rules: enable Fallback linker for Foreign Function and Memory API
    on i386 and armhf.
  * d/watch: Use fixed googletest version.
  * d/p/jdk-8336529-proposed.patch: Fix time_t migration issue on armhf,
    unable to set file last modified timestamp.

  [ Matthias Klose ]
  * Build using GCC 14.
  * Install jnativescan into jdk-headless.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 19 Jul 2024 09:01:13 +0200

openjdk-24 (24~4ea-1) experimental; urgency=medium

  * OpenJDK 24 snapshot, Build 4.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Jun 2024 19:36:22 +0200

openjdk-23 (23~28ea-1) unstable; urgency=medium

  * OpenJDK 23 snapshot, Build 28.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 28 Jun 2024 17:35:55 +0200

openjdk-23 (23~20ea-1) unstable; urgency=medium

  * OpenJDK 23 snapshot, Build 20.

  [ Vladimir Petko ]
  * Add autopkgtest to test that JNI applications using the invocation API
    can be linked.
  * Add autopkgtest for libpcsclite initialisation.

  [ Matthias Klose ]
  * Build using GCC 10 for focal.
  * Fix fontmanager build with system harfbuzz.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 01 May 2024 06:15:47 +0200

openjdk-23 (23~15ea-1) unstable; urgency=medium

  * OpenJDK 23 snapshot, Build 15.

  [ Vladimir Petko ]
  * Fix installing the s390x build.
  * Emit warning to install openjdk-*-jre package when fontmanager is
    used, but only openjdk-*-jre-headless is installed.
  * Add support to build --with-hsdis=binutils, but keep it off by default.

  [ Matthias Klose ]
  * Update cups dependencies for time_t64.

  [ Pushkar Kulkarni ]
  * copyright-generator: Derive release from debian/rules.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 23 Mar 2024 14:40:10 +0100

openjdk-23 (23~14ea-1) experimental; urgency=medium

  * OpenJDK 23 snapshot, Build 14.

  [ Vladimir Petko ]
  * Run the hotspot and jdk autopkg tests on all architectures.
  * Add bash, lsb-release and xauth as dependencies for autopkg tests.
  * Build openjdk-23-testsupport packages, containing the binaries
    required to run the autopkg tests.
  * d/t/{hotspot,jdk}-autopkgtest.{sh, in}: Set default arguments to
    tier1 tests, otherwise pass user's arguments while setting correct
    test directory and native path.
  * Fix lintian override package name.

  [ Pushkar Kulkarni ]
  * Corrections to patch arch-add-ports.diff.
  * Fix a typo in the vendor name derivation logic.

  [ Matthias Klose ]
  * Remove the GTK 2.x bits.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 18:17:32 +0100

openjdk-23 (23~13ea-1) unstable; urgency=medium

  * OpenJDK 23 snapshot, Build 13.

  * libcups2, libfontconfig1: Make it a recommends in jre-headless,
    a dependency in jre.
  * Make the dependencies for libfontmanager.so and libjsound.so
    recommendations in jre-headless, and dependencies in jre.
  * Drop build dependencies on libgtk2 | libgtk3.
  * Disable running the tests for the time_t64 bootstrap.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Mar 2024 23:53:00 +0100

openjdk-23 (23~10ea-1) unstable; urgency=medium

  * OpenJDK 23 snapshot, Build 10.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 19 Feb 2024 00:31:52 +0100

openjdk-23 (23~6ea-1) unstable; urgency=medium

  * OpenJDK 23 snapshot, Build 6.

  [ Matthias Klose ]
  * Don't try to install jhsdb on armhf with a zero-only build.
  * d/changelog: Whitespace cleanup.
  * Update build dependency on libfontconfig-dev.
  * Apply proposed patch for JDK-8307977. Addresses: #1034600.



=== debian/control ===
Source: openjdk-24
Section: java
Priority: optional
Maintainer: OpenJDK Team <openjdk-24@packages.debian.org>
Uploaders: Matthias Klose <doko@ubuntu.com>
Build-Depends: debhelper (>= 11),
  m4, lsb-release, zip, unzip,
  sharutils, gawk, cpio, procps, wdiff, pkgconf, fastjar (>= 2:0.96-0ubuntu2),
  time, strip-nondeterminism, debugedit (>= 4.16),
  jtreg7 (>= 7.4+1~) <!nocheck>, libtestng7-java <!nocheck>, xvfb <!nocheck>, xauth <!nocheck>, xfonts-base <!nocheck>, libgl1-mesa-dri [!x32] <!nocheck>, xfwm4 <!nocheck>, x11-xkb-utils <!nocheck>, dbus-x11 <!nocheck>, libasmtools-java <!nocheck>, xvfb  <!nocheck>,
  autoconf, automake, ant, ant-optional,
  g++-14 <!cross>,
  openjdk-23-jdk-headless:native | openjdk-24-jdk-headless:native,
  libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig-dev, libfreetype-dev, libharfbuzz-dev,
  libffi-dev, libffi-dev:native,
  zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev,
  libnss3-dev (>= 2:3.17.1),
  openjdk-24-jdk-headless <cross>,
Build-Depends-Indep: graphviz, pandoc,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://openjdk.java.net/
Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk
Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git

Package: openjdk-24-jdk-headless
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-24-jre-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Suggests: openjdk-24-demo, openjdk-24-source
Provides: java-sdk-headless (= ${vm:Version}), java2-sdk-headless,
  java5-sdk-headless, java6-sdk-headless,
  java7-sdk-headless, java8-sdk-headless,
  java9-sdk-headless, java10-sdk-headless,
  java11-sdk-headless, java12-sdk-headless,
  java13-sdk-headless, java14-sdk-headless, java15-sdk-headless,
  java16-sdk-headless, java17-sdk-headless,
  java18-sdk-headless, java19-sdk-headless,
  java20-sdk-headless, java21-sdk-headless,
  java22-sdk-headless, java23-sdk-headless, java24-sdk-headless,
  java-compiler
Description: OpenJDK Development Kit (JDK) (headless)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-24-jre-headless
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: ${jredefault:Depends}, ${cacert:Depends},
  ${jcommon:Depends}, ${dlopenhl:Depends},
  ${mountpoint:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenhl:Recommends},
  ${fontmanager:Recommends}, ${jsound:Recommends}
Suggests: libnss-mdns,
  fonts-dejavu-extra,
  fonts-ipafont-gothic, fonts-ipafont-mincho, fonts-wqy-microhei | fonts-wqy-zenhei, fonts-indic,
Provides: java-runtime-headless (= ${vm:Version}), java2-runtime-headless,
  java5-runtime-headless, java6-runtime-headless,
  java7-runtime-headless, java8-runtime-headless,
  java9-runtime-headless, java10-runtime-headless,
  java11-runtime-headless, java12-runtime-headless,
  java13-runtime-headless, java14-runtime-headless, java15-runtime-headless,
  java16-runtime-headless, java17-runtime-headless,
  java19-runtime-headless, java20-runtime-headless, java21-runtime-headless,
  java22-runtime-headless, java23-runtime-headless,
  java24-runtime-headless,
  ${defaultvm:Provides}, ${jvm:Provides}
Description: OpenJDK Java runtime, using ${vm:Name} (headless)
 Minimal Java runtime - needed for executing non GUI Java programs,
 using ${vm:Name}.

Package: openjdk-24-jdk
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-24-jre (= ${binary:Version}),
  openjdk-24-jdk-headless (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libxt-dev
Suggests: openjdk-24-demo, openjdk-24-source, visualvm
Provides: java-sdk (= ${vm:Version}), java2-sdk, java5-sdk, java6-sdk,
  java7-sdk, java8-sdk, java9-sdk, java10-sdk, java11-sdk,
  java12-sdk, java13-sdk, java14-sdk, java15-sdk, java16-sdk, java17-sdk,
  java18-sdk, java19-sdk, java20-sdk, java21-sdk, java22-sdk,
  java23-sdk, java24-sdk,
  java-compiler
Description: OpenJDK Development Kit (JDK)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.

Package: openjdk-24-jre
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-24-jre-headless (= ${binary:Version}),
  ${dlopenjre:Depends}, ${fontmanager:Depends}, ${jsound:Depends},
  ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dlopenjre:Recommends}, ${bridge:Recommends}, fonts-dejavu-extra
Provides: java-runtime (= ${vm:Version}), java2-runtime,
  java5-runtime, java6-runtime,
  java7-runtime, java8-runtime,
  java9-runtime, java10-runtime,
  java11-runtime, java12-runtime,
  java13-runtime, java14-runtime, java15-runtime,
  java16-runtime, java17-runtime,
  java18-runtime, java19-runtime,
  java20-runtime, java21-runtime,
  java22-runtime, java23-runtime,
  java24-runtime
Description: OpenJDK Java runtime, using ${vm:Name}
 Full Java runtime environment - needed for executing Java GUI and Webstart
 programs, using ${vm:Name}.

Package: openjdk-24-demo
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-24-jre (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Description: Java runtime based on OpenJDK (demos and examples)
 OpenJDK Java runtime

Package: openjdk-24-source
Architecture: all
Multi-Arch: foreign
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-24-jdk (>= ${source:Version}),
  ${misc:Depends}
Description: OpenJDK Development Kit (JDK) source files
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the Java programming language source files
 (src.zip) for all classes that make up the Java core API.

Package: openjdk-24-doc
Section: doc
Pre-Depends: ${dpkg:Depends}
Architecture: all
Multi-Arch: foreign
Priority: optional
Depends: ${misc:Depends},
  libjs-jquery,
  libjs-jquery-ui,
  libjs-jquery-ui-theme-base,
Suggests: openjdk-24-jdk
Description: OpenJDK Development Kit (JDK) documentation
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the API documentation.

Package: openjdk-24-dbg
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Priority: optional
Section: debug
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-24-jre-headless (= ${binary:Version}),
   ${misc:Depends},${shlibs:Depends}
Recommends: openjdk-24-jre (= ${binary:Version})
Suggests: openjdk-24-jdk (= ${binary:Version})
Conflicts: ${dbg:Conflicts}
Description: Java runtime based on OpenJDK (debugging symbols)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains the debugging symbols.

Package: openjdk-24-testsupport
Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32
Multi-Arch: same
Depends: openjdk-24-jdk (= ${binary:Version}),
  build-essential, xfwm4, xvfb, dbus-x11, libatk-wrapper-java,
  libatk-wrapper-java-jni, jtreg7 (>= 7.4+1~), libtestng7-java,
  ${shlibs:Depends},
  ${misc:Depends}
Description: Java runtime based on OpenJDK (regression test support)
 OpenJDK is a development environment for building applications,
 applets, and components using the Java programming language.
 .
 This package contains all the binary files needed to run the
 OpenJDK autopkg tests.

Package: openjdk-24-jre-zero
Architecture: amd64 i386 arm64 ppc64 ppc64el riscv64 s390x
Multi-Arch: same
Priority: optional
Pre-Depends: ${dpkg:Depends}
Depends: openjdk-24-jre-headless (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: ${zerovm:Provides}
Description: Alternative JVM for OpenJDK, using Zero
 The package provides an alternative runtime using the Zero VM. Built on
 architectures in addition to the Hotspot VM as a debugging aid for those
 architectures which don't have a Hotspot VM.
 .
 The VM is started with the option `-zero'. See the README.Debian for details.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
include /usr/share/dpkg/buildflags.mk

unexport LANG LC_ALL

dh_version := $(shell dpkg-query -f '$${Version}\n' -W debhelper | sed -n 's/^\(.\).*/\1/p')

# using brace expansion and substring replacements (${var:0:2}).
SHELL = /bin/bash

# use gnu time in verbose mode if available, otherwise default to the shell builtin
ifneq (,$(wildcard /usr/bin/time))
  TIME = /usr/bin/time -v
else
  TIME = time
endif

vafilt = $(subst $(2)=,,$(filter $(2)=%,$(1)))

DPKG_VARS		:= $(shell dpkg-architecture)
DEB_HOST_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE	?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_GNU_TYPE)
DEB_HOST_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH)
DEB_BUILD_ARCH		?= $(call vafilt,$(DPKG_VARS),DEB_BUILD_ARCH)
DEB_HOST_ARCH_CPU	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_ARCH_CPU)
DEB_HOST_MULTIARCH	?= $(call vafilt,$(DPKG_VARS),DEB_HOST_MULTIARCH)

PATH := $(CURDIR)/bin:$(PATH)
export PATH

CHANGELOG_VARS := $(shell dpkg-parsechangelog | sed -n 's/ /_/g;/^[^_]/s/^\([^:]*\):_\(.*\)/\1=\2/p')
PKGSOURCE := $(call vafilt,$(CHANGELOG_VARS),Source)
PKGVERSION := $(call vafilt,$(CHANGELOG_VARS),Version)
PKGYEAR := $(shell echo $(call vafilt,$(CHANGELOG_VARS),Timestamp) | date --utc +%Y)

distribution := $(shell lsb_release --id --short)
distrel := $(shell lsb_release --codename --short)
derivative := $(shell if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
               elif dpkg-vendor --derives-from Debian; then echo Debian; \
               else echo Unknown; fi)
ifeq ($(distrel),n/a)
  distrel := sid
endif

ifneq (,$(filter $(distrel),precise))
  OBJCOPY := objcopy
  STRIP := strip
else
  OBJCOPY := $(DEB_HOST_GNU_TYPE)-objcopy
  STRIP := $(DEB_HOST_GNU_TYPE)-strip
endif

multiarch_dir = /$(DEB_HOST_MULTIARCH)

hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el riscv64 s390x
# see https://bugs.openjdk.org/browse/JDK-8321125
hotspot_archs	= amd64 i386 arm64 ppc64 ppc64el riscv64 s390x
jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc ppc64 sh4 x32
jtreg_archs	+= armel loong64 mipsel mips64el
jtreg_archs	+= riscv64

# FIXME: use bootcycle builds for zero archs?
bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),yes)
#bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), amd64 i386),yes)
#bootcycle_build =
zbootcycle_build =
zbootcycle_build = yes
ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
  bootcycle_build =
  zbootcycle_build =
endif
ifneq (,$(filter nobootcycle, $(DEB_BUILD_OPTIONS)))
  bootcycle_build =
  zbootcycle_build =
endif

ifneq (,$(filter $(distrel),lucid precise quantal raring saucy trusty utopic vivid wily lenny etch squeeze wheezy jessie))
  is_default = no
else
  is_default = yes
endif

#is_upstream_release = yes

srcdir		= .
builddir	= build
zbuilddir	= build-zero

VENDOR		= openjdk
Vendor		= OpenJDK
TOP		= usr/lib/jvm
origin		= openjdk
basename	= openjdk-$(shortver)
ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))
  priority	= $(if $(filter yes, $(is_default)),2411,2409)
  vm_name	= Hotspot JIT
else
  priority	= $(if $(filter yes, $(is_default)),2404,2403)
  vm_name	= Hotspot Zero
endif
jvmver		= 1.24.0
shortver	= 24
v_debian	:= $(shell echo $(PKGVERSION) | sed 's/ea//' | sed 's/\~us[[:digit:]]\+//')
v_upstream	:= $(shell echo $(v_debian) | sed 's/-[^-][^-]*$$//')
v_pkgrel	:= $(shell echo $(v_debian) | sed 's/^.*-//')

ifeq (yes,$(is_upstream_release))
  v_upbase      := $(word 1, $(subst +, , $(v_upstream)))
  v_upbuild     := $(word 2, $(subst +, , $(v_upstream)))
  ifneq ($(v_debian),$(v_upbase)+$(v_upbuild)-$(v_pkgrel))
    $(error wrong version: $(v_upbase)+$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
  endif
else
  v_upbase      := $(word 1, $(subst ~, , $(v_upstream)))
  v_upbuild     := $(word 2, $(subst ~, , $(v_upstream)))
  ifneq ($(v_debian),$(v_upbase)~$(v_upbuild)-$(v_pkgrel))
    $(error wrong version: $(v_upbase)~$(v_upbuild)-$(v_pkgrel) should be: $(v_debian))
  endif
endif

ifneq (,$(DEB_HOST_MULTIARCH))
  jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
  jdiralias	= java-$(jvmver)-$(origin)-$(DEB_HOST_ARCH)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)-common
  commonbasedir	= $(basedir)
  etcdir	= etc/java-$(shortver)-$(origin)
  testsuitedir	=	$(basedir)/testsuite
else
  jdirname	= java-$(shortver)-$(origin)
  jdiralias	= java-$(jvmver)-$(origin)
  basedir	= $(TOP)/$(jdirname)
  commonbasedir	= $(TOP)/java-$(shortver)-$(origin)
  etcdir	= etc/$(jdirname)
  testsuitedir	=	$(basedir)/testsuite
endif
security	= $(etcdir)/security
ifeq ($(bootcycle_build),yes)
  sdkimg	= bootcycle-build/images/jdk
  build_target	= bootcycle-images test-image
  testimg	= images/test
else
  sdkimg	= images/jdk
  build_target	= images test-image
  testimg	= images/test
endif
ifeq ($(zbootcycle_build),yes)
  zsdkimg	= bootcycle-build/images/jdk
  zbuild_target	= bootcycle-images test-image
else
  zsdkimg	= images/jdk
  zbuild_target	= images test-image
endif

# Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
COMMA=,
SPACE = $(EMPTY) $(EMPTY)
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS = $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

ifneq (,$(filter $(distrel), bookworm bullseye))
  jtreg_pkg = jtreg# debian will have jtreg7 in jtreg package
  testng_pkg = libtestng7-java
else
  jtreg_pkg = jtreg7
  testng_pkg = libtestng7-java
endif

with_check = $(if $(findstring nocheck, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(DEB_HOST_ARCH), alpha arc armel hppa ia64 loong64 mipsel mips64el powerpc riscv64 x32))
  with_check = disabled running check on $(DEB_HOST_ARCH)
endif
# no jtreg backport yet
ifneq (,$(filter $(distrel), precise trusty xenial bionic bookworm bullseye))
  with_check = disabled for $(distrel), no $(jtreg_pkg)
endif
#with_check = disabled, more recent jtreg needed

with_docs = $(if $(findstring nodoc, $(DEB_BUILD_OPTIONS)),,yes)
ifneq (,$(filter $(distrel), precise trusty))
  with_docs =
endif
#with_check = disabled for this upload

with_wqy_zenhai = $(if $(filter $(distrel),lenny),,yes)

arch_map	:= alpha=alpha arc=arc arm=arm armel=arm armhf=arm arm64=aarch64 amd64=amd64 hppa=parisc i386=i586 loong64=loong64 m68k=m68k mips=mips mipsel=mipsel mips64=mips64 mips64el=mips64el powerpc=ppc ppc64=ppc64 ppc64el=ppc64le riscv64=riscv64 sparc=sparc sparc64=sparcv9 sh4=sh s390x=s390x ia64=ia64 x32=x32

jvmarch		:= $(strip $(patsubst $(DEB_HOST_ARCH_CPU)=%, %, \
			$(filter $(DEB_HOST_ARCH_CPU)=%, $(arch_map))))
ifeq ($(DEB_HOST_ARCH),x32)
  jvmarch := x32
endif

default_vm = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),hotspot,zero)

any_archs = alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32

altzero_archs = $(hotspot_archs)
ifneq (,$(filter $(distrel),trusty))
  altzero_archs := $(filter-out arm64, $(altzero_archs))
endif

ifneq (,$(filter noaltzero, $(DEB_BUILD_OPTIONS)))
  altzero_archs =
else ifneq (,$(filter $(DEB_HOST_ARCH), $(altzero_archs)))
  alternate_vms += zero
  zero_dir = zero
endif

# needed for the jexec build
export DEBIAN_JDK_BASE_DIR := /$(basedir)

BOOTJDK_HOME := $(strip $(subst /bin/javac,, $(firstword $(wildcard \
			/usr/lib/jvm/java-24-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
			/usr/lib/jvm/java-23-openjdk-$(DEB_BUILD_ARCH)/bin/javac \
		))))

ifeq ($(DEB_BUILD_ARCH),$(DEB_HOST_ARCH))
  BUILDJDK_HOME = $(CURDIR)/$(builddir)/$(sdkimg)
else
  BUILDJDK_HOME = $(BOOTJDK_HOME)
endif

ifneq (,$(filter $(distrel),saucy))
  export CC = gcc-4.8
  export CXX = g++-4.8
  bd_gcc = g++-4.8,
else ifneq (,$(filter $(distrel),utopic vivid jessie))
  export CC = gcc-4.9
  export CXX = g++-4.9
  bd_gcc = g++-4.9,
else ifneq (,$(filter $(distrel),wily))
  ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))

## openjdk-24 24~16ea

=== debian/changelog ===
openjdk-24 (24~16ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 16.
  * Bump standards version.
  * Refresh patches.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Sep 2024 17:08:21 +0200

openjdk-24 (24~14ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 14.

  * Stop providing the versioned names javaNN-sdk-headless, javaNN-sdk,
    javaNN-runtime-headless, javaNN-runtime-headless. The versioned
    provides java-sdk-headless, java-sdk, java-runtime-headless and
    java-runtime-headless exist since OpenJDK 17.

  [ Vladimir Petko ]
  * d/p/reproducible-properties-timestamp.diff: Use PrivilegedAction
    to avoid SecurityManager exception.
  * Enable dtrace support.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Sep 2024 22:24:27 +0200

=== debian/control ===
--- 
+++ 
@@ -13,12 +13,12 @@
   openjdk-23-jdk-headless:native | openjdk-24-jdk-headless:native,
   libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig-dev, libfreetype-dev, libharfbuzz-dev,
   libffi-dev, libffi-dev:native,
-  zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev,
+  zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, systemtap-sdt-dev [!sh4],
   libnss3-dev (>= 2:3.17.1),
   openjdk-24-jdk-headless <cross>,
 Build-Depends-Indep: graphviz, pandoc,
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://openjdk.java.net/
 Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk
 Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git
@@ -30,17 +30,7 @@
 Depends: openjdk-24-jre-headless (= ${binary:Version}),
   ${shlibs:Depends}, ${misc:Depends}
 Suggests: openjdk-24-demo, openjdk-24-source
-Provides: java-sdk-headless (= ${vm:Version}), java2-sdk-headless,
-  java5-sdk-headless, java6-sdk-headless,
-  java7-sdk-headless, java8-sdk-headless,
-  java9-sdk-headless, java10-sdk-headless,
-  java11-sdk-headless, java12-sdk-headless,
-  java13-sdk-headless, java14-sdk-headless, java15-sdk-headless,
-  java16-sdk-headless, java17-sdk-headless,
-  java18-sdk-headless, java19-sdk-headless,
-  java20-sdk-headless, java21-sdk-headless,
-  java22-sdk-headless, java23-sdk-headless, java24-sdk-headless,
-  java-compiler
+Provides: java-sdk-headless (= ${vm:Version}), java-compiler
 Description: OpenJDK Development Kit (JDK) (headless)
  OpenJDK is a development environment for building applications,
  applets, and components using the Java programming language.
@@ -58,16 +48,7 @@
 Suggests: libnss-mdns,
   fonts-dejavu-extra,
   fonts-ipafont-gothic, fonts-ipafont-mincho, fonts-wqy-microhei | fonts-wqy-zenhei, fonts-indic,
-Provides: java-runtime-headless (= ${vm:Version}), java2-runtime-headless,
-  java5-runtime-headless, java6-runtime-headless,
-  java7-runtime-headless, java8-runtime-headless,
-  java9-runtime-headless, java10-runtime-headless,
-  java11-runtime-headless, java12-runtime-headless,
-  java13-runtime-headless, java14-runtime-headless, java15-runtime-headless,
-  java16-runtime-headless, java17-runtime-headless,
-  java19-runtime-headless, java20-runtime-headless, java21-runtime-headless,
-  java22-runtime-headless, java23-runtime-headless,
-  java24-runtime-headless,
+Provides: java-runtime-headless (= ${vm:Version}),
   ${defaultvm:Provides}, ${jvm:Provides}
 Description: OpenJDK Java runtime, using ${vm:Name} (headless)
  Minimal Java runtime - needed for executing non GUI Java programs,
@@ -82,12 +63,7 @@
   ${shlibs:Depends}, ${misc:Depends}
 Recommends: libxt-dev
 Suggests: openjdk-24-demo, openjdk-24-source, visualvm
-Provides: java-sdk (= ${vm:Version}), java2-sdk, java5-sdk, java6-sdk,
-  java7-sdk, java8-sdk, java9-sdk, java10-sdk, java11-sdk,
-  java12-sdk, java13-sdk, java14-sdk, java15-sdk, java16-sdk, java17-sdk,
-  java18-sdk, java19-sdk, java20-sdk, java21-sdk, java22-sdk,
-  java23-sdk, java24-sdk,
-  java-compiler
+Provides: java-sdk (= ${vm:Version}), java-compiler
 Description: OpenJDK Development Kit (JDK)
  OpenJDK is a development environment for building applications,
  applets, and components using the Java programming language.
@@ -100,17 +76,7 @@
   ${dlopenjre:Depends}, ${fontmanager:Depends}, ${jsound:Depends},
   ${shlibs:Depends}, ${misc:Depends}
 Recommends: ${dlopenjre:Recommends}, ${bridge:Recommends}, fonts-dejavu-extra
-Provides: java-runtime (= ${vm:Version}), java2-runtime,
-  java5-runtime, java6-runtime,
-  java7-runtime, java8-runtime,
-  java9-runtime, java10-runtime,
-  java11-runtime, java12-runtime,
-  java13-runtime, java14-runtime, java15-runtime,
-  java16-runtime, java17-runtime,
-  java18-runtime, java19-runtime,
-  java20-runtime, java21-runtime,
-  java22-runtime, java23-runtime,
-  java24-runtime
+Provides: java-runtime (= ${vm:Version})
 Description: OpenJDK Java runtime, using ${vm:Name}
  Full Java runtime environment - needed for executing Java GUI and Webstart
  programs, using ${vm:Name}.

## openjdk-24 24~20ea

=== debian/changelog ===
openjdk-24 (24~20ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 20.

  [ Vladimir Petko ]
  * d/rules: Do not include dtrace support for S390x (JDK-8305174).
  * d/t/problems.csv: Disable jdk/sun/security/util/Debug/DebugOptions.java
    due to JDK-8339713.
  * d/rules: Disable hotspot for i386 (JDK-8341871).

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Oct 2024 09:05:23 +0200

=== debian/rules ===
--- 
+++ 
@@ -57,8 +57,10 @@
 multiarch_dir = /$(DEB_HOST_MULTIARCH)
 
 hotspot_archs	= amd64 i386 arm64 armhf ppc64 ppc64el riscv64 s390x
-# see https://bugs.openjdk.org/browse/JDK-8321125
-hotspot_archs	= amd64 i386 arm64 ppc64 ppc64el riscv64 s390x
+# see https://bugs.openjdk.org/browse/JDK-8321125 (armhf removed)
+# see https://bugs.openjdk.org/browse/JDK-8338285,
+# https://bugs.openjdk.org/browse/JDK-8341871 (i386 removed)
+hotspot_archs	= amd64 arm64 ppc64 ppc64el riscv64 s390x
 jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc ppc64 sh4 x32
 jtreg_archs	+= armel loong64 mipsel mips64el
 jtreg_archs	+= riscv64
@@ -234,6 +236,3 @@
 else ifneq (,$(filter $(distrel),utopic vivid jessie))
   export CC = gcc-4.9
   export CXX = g++-4.9
-  bd_gcc = g++-4.9,
-else ifneq (,$(filter $(distrel),wily))
-  ifneq (,$(filter $(DEB_HOST_ARCH), $(hotspot_archs)))

## openjdk-24 24~22ea

=== debian/changelog ===
openjdk-24 (24~22ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 22.
  * Consolidate setting of dtrace architectures.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 01 Nov 2024 10:57:23 +0100

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
   openjdk-23-jdk-headless:native | openjdk-24-jdk-headless:native,
   libxtst-dev, libxi-dev, libxt-dev, libxaw7-dev, libxrender-dev, libcups2-dev, libasound2-dev, liblcms2-dev, libxinerama-dev, libkrb5-dev, xsltproc, libpcsclite-dev, libxrandr-dev, libelf-dev, libfontconfig-dev, libfreetype-dev, libharfbuzz-dev,
   libffi-dev, libffi-dev:native,
-  zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, systemtap-sdt-dev [!sh4],
+  zlib1g-dev:native, zlib1g-dev, libattr1-dev, libpng-dev, libjpeg-dev, libgif-dev, systemtap-sdt-dev [!powerpc !ppc64 !ppc64el !sh4 !s390x],
   libnss3-dev (>= 2:3.17.1),
   openjdk-24-jdk-headless <cross>,
 Build-Depends-Indep: graphviz, pandoc,
@@ -154,7 +154,7 @@
  OpenJDK autopkg tests.
 
 Package: openjdk-24-jre-zero
-Architecture: amd64 i386 arm64 ppc64 ppc64el riscv64 s390x
+Architecture: amd64 arm64 ppc64 ppc64el riscv64 s390x
 Multi-Arch: same
 Priority: optional
 Pre-Depends: ${dpkg:Depends}

=== debian/watch ===
version=4
opts=\
repack,repacksuffix=ea,oversionmangle=s/\+(\d+)/\~$1/,dversionmangle=s/\~(\d*)ea$/\+$1/,\
compression=xz, \
    https://github.com/openjdk/jdk/tags \
    (?:.*?/)?jdk-(24[\+\.\d]*)\.tar\.gz

opts=\
component=googletest,\
repack,\
compression=xz \
    https://github.com/google/googletest/tags \
    (?:.*?/)?v(1.14.0)\.tar\.gz 1.14.0

## openjdk-24 24~30ea

=== debian/changelog ===
openjdk-24 (24~30ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 30.

  [ Vladimir Petko ]
  * d/rules: Set JVM thread size and Java thread size for power architectures and S390x
    to avoid a stack overflow error.

  [ Matthias Klose ]
  * d/rules: Also do the above fix for alpha and sparc64.
  * Try to work-around a ftbfs on alpha.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 05 Jan 2025 09:55:53 +0100

openjdk-24 (24~29ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 29.
  * Update VCS attributes.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 20 Dec 2024 09:36:43 +0100

openjdk-24 (24~26ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 26.

  [ Matthias Klose ]
  * d/patches/{atk-wrapper-security,update-permission-test}: Disable.
  * d/patches/warn-fontmanager: Update.

  [ Pushkar Kulkarni ]
  * For jammy, work around GCC ICE on armhf. See LP #1953128.
  * d/t/problems.csv: Update based on recent JTREG runs.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 29 Nov 2024 12:21:53 +0100

=== debian/control ===
--- 
+++ 
@@ -20,8 +20,8 @@
 Rules-Requires-Root: no
 Standards-Version: 4.7.0
 Homepage: https://openjdk.java.net/
-Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk
-Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git
+Vcs-Browser: https://salsa.debian.org/openjdk-team/openjdk/tree/openjdk-24
+Vcs-Git: https://salsa.debian.org/openjdk-team/openjdk.git -b openjdk-24
 
 Package: openjdk-24-jdk-headless
 Architecture: alpha amd64 arc armel armhf arm64 hppa i386 ia64 loong64 mips mipsel mips64 mips64el powerpc ppc64 ppc64el m68k riscv64 sh4 sparc sparc64 s390x x32

## openjdk-24 24~33ea

=== debian/changelog ===
openjdk-24 (24~33ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 33.

  [ Vladimir Petko ]
  * d/p/jdk-8347014-proposed.patch: Define MAP_FIXED_NOREPLACE_value for alpha.
  * d/t/problems.csv: Add openjdk-24 and openjdk-25 to the problems.csv.
  * d/rules: Dump complete hs_err_pid and replay_pid logs to stdout.
  * d/t/problems.csv: Fix typo - remove jdk prefix for
    sun/security/util/Debug/DebugOptions.java.
  * d/rules: Disable dtrace on jammy armhf (was not enabled before and cannot
    be built due to a GCC ICE (see LP #2091225).

  [ Matthias Klose ]
  * Try to work-around a ftbfs on alpha. For now we keep the
    zero-alpha-workaround patch enabled instead of jdk-8347014-proposed.
  * d/rules: Also dump logs for zero builds and for build failures.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2025 21:08:07 +0100

## openjdk-24 24%2B36

=== test/jdk/java/rmi/reliability/benchmark/bench/Makefile ===
#
# Copyright (c) 1999, 2024, Oracle and/or its affiliates. All rights reserved.
# DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
#
# This code is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License version 2 only, as
# published by the Free Software Foundation.
#
# This code is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# version 2 for more details (a copy is included in the LICENSE file that
# accompanied this code).
#
# You should have received a copy of the GNU General Public License version
# 2 along with this work; if not, write to the Free Software Foundation,
# Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
#
# Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
# or visit www.oracle.com if you need additional information or have any
# questions.
#

#
#
#
# Benchmarking harness makefile
#

BUILD_DIR = ..
JAVA_FILES = BenchInfo.java \
	Benchmark.java \
	ConfigFormatException.java \
	Harness.java \
	HtmlReporter.java \
	Reporter.java \
	TextReporter.java \
	Util.java \
	XmlReporter.java


all: .classes

.classes: $(JAVA_FILES)
	javac -d $(BUILD_DIR) $(JAVA_FILES)
	touch .classes

clean:
	rm -f *.class .classes

=== debian/changelog ===
openjdk-24 (24+36-1) unstable; urgency=medium

  * OpenJDK 24 final release.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Mar 2025 18:15:08 +0100

openjdk-24 (24~36ea-1) unstable; urgency=medium

  * OpenJDK 24 snapshot, Build 36.

  [ Pushkar Kulkarni ]
  * d/control: New graal-builder jdk package.
  * d/rules: Generate graal-builder jdk package.

  [ Matthias Klose ]
  * Fix jvmci package description.
  * Clean up jvmci package.
  * Install changelog and copyright for jvmci.
  * Remove some man pages, that appear with 24~36ea without binaries:
    jabswitch.1, jaccess*.1, kinit.1, klist.1, ktab.1.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2025 14:41:09 +0100

## openjdk-24 24+36

=== debian/control ===
--- 
+++ 
@@ -153,6 +153,18 @@
  This package contains all the binary files needed to run the
  OpenJDK autopkg tests.
 
+Package: openjdk-24-jvmci-jdk
+Architecture: amd64
+Multi-Arch: same
+Priority: optional
+Pre-Depends: ${dpkg:Depends}
+Depends: ${jredefault:Depends}, ${cacert:Depends},
+  ${jcommon:Depends}, ${dlopenhl:Depends},
+  ${mountpoint:Depends},
+  ${shlibs:Depends}, ${misc:Depends}
+Description: JVMCI-enabled SDK for building graalvm
+  This package provides a JVMCI-enabled GraalVM builder Java SDK.
+
 Package: openjdk-24-jre-zero
 Architecture: amd64 arm64 ppc64 ppc64el riscv64 s390x
 Multi-Arch: same

=== debian/rules ===
--- 
+++ 
@@ -61,9 +61,12 @@
 # see https://bugs.openjdk.org/browse/JDK-8338285,
 # https://bugs.openjdk.org/browse/JDK-8341871 (i386 removed)
 hotspot_archs	= amd64 arm64 ppc64 ppc64el riscv64 s390x
+
 jtreg_archs	= $(hotspot_archs) alpha ia64 powerpc ppc64 sh4 x32
 jtreg_archs	+= armel loong64 mipsel mips64el
 jtreg_archs	+= riscv64
+
+jvmci_archs	= amd64
 
 # FIXME: use bootcycle builds for zero archs?
 bootcycle_build = $(if $(filter $(DEB_HOST_ARCH), $(hotspot_archs)),yes)
@@ -86,11 +89,12 @@
   is_default = yes
 endif
 
-#is_upstream_release = yes
+is_upstream_release = yes
 
 srcdir		= .
 builddir	= build
 zbuilddir	= build-zero
+jvmci_builddir	= build-jvmci
 
 VENDOR		= openjdk
 Vendor		= OpenJDK
@@ -128,6 +132,7 @@
   jdirname	= java-$(shortver)-$(origin)-$(DEB_HOST_ARCH)
   jdiralias	= java-$(jvmver)-$(origin)-$(DEB_HOST_ARCH)
   basedir	= $(TOP)/$(jdirname)
+  jvmci_basedir = $(basedir)-jvmci
   commonbasedir	= $(TOP)/java-$(shortver)-$(origin)-common
   commonbasedir	= $(basedir)
   etcdir	= etc/java-$(shortver)-$(origin)
@@ -136,6 +141,7 @@
   jdirname	= java-$(shortver)-$(origin)
   jdiralias	= java-$(jvmver)-$(origin)
   basedir	= $(TOP)/$(jdirname)
+  jvmci_basedir = $(basedir)-jvmci
   commonbasedir	= $(TOP)/java-$(shortver)-$(origin)
   etcdir	= etc/$(jdirname)
   testsuitedir	=	$(basedir)/testsuite
@@ -158,6 +164,8 @@
   zbuild_target	= images test-image
 endif
 
+jvmci_img	= images/graal-builder-jdk
+jvmci_target	= graal-builder-image
 # Support parallel=<n> in DEB_BUILD_OPTIONS (see #209008)
 COMMA=,
 SPACE = $(EMPTY) $(EMPTY)
@@ -229,10 +237,3 @@
   BUILDJDK_HOME = $(BOOTJDK_HOME)
 endif
 
-ifneq (,$(filter $(distrel),saucy))
-  export CC = gcc-4.8
-  export CXX = g++-4.8
-  bd_gcc = g++-4.8,
-else ifneq (,$(filter $(distrel),utopic vivid jessie))
-  export CC = gcc-4.9
-  export CXX = g++-4.9

## openjdk-24 24.0.1+9~us1

=== debian/changelog ===
openjdk-24 (24.0.1+9~us1-0ubuntu1~25.04) plucky-security; urgency=medium

  * OpenJDK 24.0.1 release, build 9.
    - CVEs:
      + CVE-2025-21587
      + CVE-2025-30691
      + CVE-2025-30698

  [ Vladimir Petko ]
  * d/t/problems.csv: Disable tests failing due to upstream bugs.

  [ Matthias Klose ]
  * Honour DEB_BUILD_OPTIONS=parallel=N while running jtreg tests
    (Helmut Grohne). Addresses: #1095920.

  * Upload to Ubuntu 25.04.

 -- Pushkar Kulkarni <pushkar.kulkarni@canonical.com>  Thu, 17 Apr 2025 10:41:16 +0530

## openjdk-24 24.0.1+9

=== debian/changelog ===
openjdk-24 (24.0.1+9-1ubuntu1) questing; urgency=medium

  * d/p/jdk-8359735.patch: fix process tests failing in Ubuntu 25.10
    (questing).
  * d/rules: disable C2 compiler to workaround LP: 2095441.

 -- Vladimir Petko <vladimir.petko@canonical.com>  Tue, 08 Jul 2025 11:45:40 +1200

openjdk-24 (24.0.1+9-1) unstable; urgency=high

  * OpenJDK 24 24.1.0 release.
    - Addresses CVE-2025-30698, CVE-2025-30691, CVE-2025-21587.

  [ Vladimir Petko ]
  * d/t/problems.csv: Disable tests failing due to upstream bugs.

  [ Matthias Klose ]
  * Honour DEB_BUILD_OPTIONS=parallel=N while running jtreg tests (Helmut
    Grohne). Addresses: #1095920.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 23 Apr 2025 13:56:34 +0200
